//
//  kp.h
//
//  Created by Mike Holenderski on 12/9/13.
//  Copyright (c) 2013 Mike. All rights reserved.
//

#ifndef SmartMood_heart_kp_h
#define SmartMood_heart_kp_h

#include <stdbool.h>
#include "kpi_low.h"

#define kKPNameMaxLen 100
typedef char KPUri[SS_URI_MAX_LEN];

/*
 * Joining and leaving a smart space
 */

int KPJoin(char* space, char* node, char* ip, int port);
void KPLeave();

/*
 * Generic value store
 */
 
int KPGetObjects(char* subject, char* predicate, KPUri* uris, int maxNumUris);
void KPGetValue(char* subject, char* predicate, char* value);

void KPAddObject(char* subject, char* predicate, char* uri);
void KPUpdateObject(char* subject, char* predicate, char* object);
void KPRemoveObject(char * uri);

/*
 * Utility functions
 */

bool KPStringToBool(char* str);
int KPStringToInt(char* str);
float KPStringToFloat(char* str);

#endif
