//
//  kp_sensor.c
//  SmartKPI
//
//  Created by Mike on 14/9/13.
//  Copyright (c) 2013 Mike. All rights reserved.
//

#include "kp_sensor.h"
#include "kp_protected.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void KPAddSensor(char* name, char* location, char* unit, char* value, char* uri) {
  if (!ss_joined) { printf("Trying to operate on smart space before joining one\n"); return; }

  KPAddObject(ss_info.space_id, "hasSensor", uri);

  ss_triple_t* triple = NULL;

  ss_add_triple(&triple, uri, "hasName", name, SS_RDF_TYPE_URI, SS_RDF_TYPE_LIT);
  ss_add_triple(&triple, uri, "hasLocation", location, SS_RDF_TYPE_URI, SS_RDF_TYPE_LIT);
  ss_add_triple(&triple, uri, "hasUnitType", unit, SS_RDF_TYPE_URI, SS_RDF_TYPE_LIT);
  ss_add_triple(&triple, uri, "hasValue", value, SS_RDF_TYPE_URI, SS_RDF_TYPE_LIT);

  ss_insert(ss_joined, triple, NULL);
  ss_delete_triples(triple);
}

void KPUpdateSensor(char * uri, char * value) {
  if (!ss_joined) { printf("Trying to operate on smart space before joining one\n"); return; }

  ss_triple_t * insert_triples = NULL;
  ss_triple_t * removed_triples = NULL;

  ss_add_triple(&insert_triples, uri, "hasValue", value, SS_RDF_TYPE_URI, SS_RDF_TYPE_LIT);
  ss_add_triple(&removed_triples, uri, "hasValue", SS_RDF_SIB_ANY, SS_RDF_TYPE_URI, SS_RDF_TYPE_URI);

  ss_update(ss_joined, insert_triples, removed_triples, NULL);

  ss_delete_triples(insert_triples);
  ss_delete_triples(removed_triples);
}

void KPRemoveSensor(char * uri) {
  KPRemoveObject(uri);
}